if (document.location.href.indexOf("onepage") != -1) {
    var onepage = true;
} else {
    var onepage = false;
}
var submit = true;
var verifCentralpay = true;
var old_url = '/checkout/multishipping/overview/';
/**
 * Created by Centralpay on 16/05/16.
 */

var cardIcon = [{
    type: "cc-maestro",
    patterns: [5018, 502, 503, 506, 56, 58, 639, 6220, 67],
    length: [12, 13, 14, 15, 16, 17, 18, 19]
}, {
    type: "cc-forbrugsforeningen",
    patterns: [600],
    length: [16]
}, {
    type: "cc-dankort",
    patterns: [5019],
    length: [16]
}, {
    type: "cc-visa",
    patterns: [4],
    length: [13, 16]
}, {
    type: "cc-mastercard",
    patterns: [51, 52, 53, 54, 55, 22, 23, 24, 25, 26, 27],
    length: [16]
}, {
    type: "cc-amex",
    patterns: [34, 37],
    length: [15]
}, {
    type: "cc-diners-club",
    patterns: [30, 36, 38, 39],
    length: [14]
}, {
    type: "cc-discover",
    patterns: [60, 64, 65, 622],
    length: [16]
}, {
    type: "cc-unionpay",
    patterns: [62, 88],
    length: [16, 17, 18, 19]
}, {
    type: "cc-jcb",
    patterns: [35],
    length: [16]
}];


function iconCard(number) {
    // Remove spaces and hyphens
    number = (number + "").replace(/\s+|-/g, "");
    var card, p, pattern, i, j, len, len1, ref;
    for (i = 0, len = cardIcon.length; i < len; i++) {
        card = cardIcon[i];
        ref = card.patterns;
        for (j = 0, len1 = ref.length; j < len1; j++) {
            pattern = ref[j];
            p = pattern + "";
            if (number.substr(0, p.length) === p) {
                return card.type;
            }
        }
    }
}

function updateCardNumberIcon() {

    var num = document.getElementById("num");
    var parentNode = num.parentNode;
    // Remove existing cardIcon
    var cardIcon = parentNode.querySelector('.cardIcon');
    if (cardIcon) {
        parentNode.removeChild(cardIcon);
    }
    var newCardIcon = iconCard(num.value);
    if (newCardIcon) {
        // New cardIcon
        var spanIcon = document.createElement('span');
        spanIcon.className = "cardIcon " + newCardIcon;
        parentNode.appendChild(spanIcon);
    }
    if (jQuery('#num').val().length == 19) {
        jQuery("#month").focus();
    }
}

var champsForm;
function setMask() {
    if (jQuery("#num").length > 0) {
        // initForm();

        jQuery("#num").payment("formatCardNumber");
        jQuery("#month").inputmask('Regex', {regex: "^(0[1-9]|1[0-2])$"});
        jQuery("#year").inputmask('Regex', {regex: "^[0-9][0-9]$"});
        jQuery("#cvv2").payment("formatCardCVC");
        jQuery("#cvv3").payment("formatCardCVC");
        clearInterval(champsForm);
        console.log('setMask');
    }
}


(function () {
    "use strict";


    // Include validation.js
    [
        'js/validation.js'
    ].forEach(function (src) {
        var script = document.createElement('script');
        script.src = urlCentralpayJs + '/' + src;
        script.async = false;
        document.getElementsByTagName("head")[0].appendChild(script);
    });

    var merchantPublicKey;
    var currentForm;
    var defaultHandler = function (status, response) {
        var divErrors = document.querySelector('[data-centralpay="errors"]');
        divErrors.innerHTML = "";
        if (status != 200) { // Error
            var ulErrors = document.createElement('ul');
            var liErrors;
            if (status == 400) {
                var json = JSON.parse(response);
                if (json && json.errors) { // Bad Request with json response errors
                    for (var key in json.errors) {
                        liErrors = document.createElement('li');
                        liErrors.appendChild(document.createTextNode(json.errors[key]));
                        ulErrors.appendChild(liErrors);
                    }
                }
                else {
                    // Other errors
                    liErrors = document.createElement('li');
                    liErrors.appendChild(document.createTextNode('An error occurred'));
                    ulErrors.appendChild(liErrors);
                }
            }
            else {
                // Other errors
                liErrors = document.createElement('li');
                liErrors.appendChild(document.createTextNode('An error occurred'));
                ulErrors.appendChild(liErrors);
            }
            divErrors.appendChild(ulErrors);
            // Re-enable submission
            currentForm.querySelector('[type="submit"]').removeAttribute('disabled');
        }
        else {
            // Token was created
            var token = JSON.parse(response);
            // Insert cardTokenId in the form
            var inputTokenId = document.createElement('input');
            inputTokenId.setAttribute('type', 'hidden');
            inputTokenId.setAttribute('name', 'cardTokenId');
            inputTokenId.value = token.cardTokenId;
            currentForm.appendChild(inputTokenId);
            // Remove submit event
            currentForm.removeEventListener('submit', defaultHandler);
            // Submit the form
            if (submit)
                currentForm.submit();
        }
    };

    var initForm = function () {
        var temp = jQuery('#name_centralpay').closest('form');

        var form = document.querySelector('#' + temp.attr('id'));


        if (form && form.nodeName === "FORM") {

            form.addEventListener('submit', function (e) {

                // Prevent other event listener
                Centralpay.utils.safePreventEvent(e);
                // Disable the submit button of the form to prevent repeated clicks
                form.querySelector('[type="submit"]').setAttribute('disabled', 'disabled');

                // Request a token from Centralpay
                Centralpay.card.createToken(form, defaultHandler);
                return false;
            });
        }
    };

    // Object Centralpay
    this.Centralpay = {};
    // Object card in Centralpay
    this.Centralpay.card = {
        createToken: function (form, handler) {
            if (verifCentralpay) {
                currentForm = form;
                var self = this;
                var field, query = '';
                // Construction postData query
                query += 'merchantPublicKey=' + merchantPublicKey;
                if (typeof form == 'object' && form.nodeName == "FORM") {
                    var centralpayElements = form.querySelectorAll('[data-centralpay]');
                    for (var i = centralpayElements.length - 1; i >= 0; i--) {
                        field = centralpayElements[i];
                        if (field.hasAttribute('data-centralpay') && field.getAttribute('data-centralpay') != "errors") {
                            query += '&' + field.getAttribute('data-centralpay') + "=" + encodeURIComponent(field.value).replace(/%20/g, '+');
                        }
                    }
                }
                // Ajax call
                var xhr = new XMLHttpRequest();
                xhr.open('POST', urlCentralpayApi + '/v2/rest/cardToken');
                xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                xhr.onreadystatechange = function () {
                    if (xhr.readyState == 4) {
                        handler(xhr.status, xhr.responseText);
                    }
                };
                xhr.send(query);
            }
        },
        setMerchantPublicKey: function (key) {
            merchantPublicKey = key;
        }
    };
    // Checks whether a data-centralpay="form" is present in a form of the page, in this case a submit event and a handler will be applied to the form
    // Otherwise the merchant will handle the event submit itself with the creation of the token
    initForm();
}).call(this);


var currentForm;
var defaultHandlerCP = function (status, response) {
    var divErrors = document.querySelector('[data-centralpay="errors"]');
    divErrors.innerHTML = "";
    var hasError = false;
    jQuery('.validation-advice').remove();
    if (status != 200) { // Error
        var ulErrors = document.createElement('ul');
        var liErrors;

        if (status == 400) {

            var json = JSON.parse(response);
            if (json && json.errors) { // Bad Request with json response errors
                for (var key in json.errors) {
                    if (key == 'card[*]') {
                        jQuery('#year').after('<div class="validation-advice">' + json.errors[key] + '</div>');
                    }
                    if (key == 'card[cvc]') {
                        jQuery('#cvv2').parent().after('<div class="validation-advice">' + json.errors[key] + '</div>');
                    }
                    if (key == 'card[number]') {
                        jQuery('#num').after('<div class="validation-advice">' + json.errors[key] + '</div>');
                    }
                }
            } else {
                // Other errors
                liErrors = document.createElement('li');
                liErrors.appendChild(document.createTextNode('An error was occured'));
                ulErrors.appendChild(liErrors);
                hasError = true;
            }
        } else {
            // Other errors
            liErrors = document.createElement('li');
            liErrors.appendChild(document.createTextNode('An error was occured'));
            ulErrors.appendChild(liErrors);
            hasError = true;
        }

        if (hasError) {
            divErrors.appendChild(ulErrors);
        } else {
            jQuery('.payment-errors').html('');
        }
        // Re-enable submission
        jQuery('[type="submit"]').removeAttr('disabled');
    }
    else {
        // Token was created
        var token = JSON.parse(response);
        // Insert cardTokenId in the form
        jQuery("input[name='cardTokenId']").remove();

        var inputTokenId = document.createElement('input');
        inputTokenId.setAttribute('type', 'hidden');
        inputTokenId.setAttribute('name', 'cardTokenId');

        inputTokenId.value = token.cardTokenId;
        var temp = jQuery('#name_centralpay').closest('form');

        var form = document.querySelector('#' + temp.attr('id'));
        form.appendChild(inputTokenId);
        // Remove submit event
        form.removeEventListener('submit', defaultHandlerCP);
        // Submit the form
        if (!submit) {

            var payment2 = new Payment('co-payment-form', savePayementUrl);
            payment2.save();
        } else {
            form.submit();
        }

    }
};


function initForm(event) {
    var temp = jQuery('#name_centralpay').closest('form');

    var form = document.querySelector('#' + temp.attr('id'));

    //   alert('ok');

    // if (form && form.nodeName === "FORM") {
    if (form) {


        jQuery('.payment-errors').html('');
        if (verifCentralpay == true) {
            // Prevent other event listener
            Centralpay.utils.safePreventEvent(event);
            // Disable the submit button of the form to prevent repeated clicks
            jQuery('[type="submit"]').attr('disabled', 'disabled');
            // Request a token from Centralpay
            Centralpay.card.createToken(form, defaultHandlerCP);
        }
    }
}

jQuery(function () {


    jQuery(document).bind('DOMNodeInserted', function (e) {
        var element = e.target;

        if (jQuery(element).attr('id') == 'dt_method_custompaymentmethod') {
          //  console.log(element);
            if (jQuery('#p_method_custompaymentmethod').is(':checked')) {

                jQuery('#checkout-step-payment .button').removeAttr('onclick');
                jQuery('#name_centralpay').closest('form').data('centralpay', 'form');
            } else {

                jQuery('#checkout-step-payment .button').attr('onclick', 'payment.save();');
            }
            setMask();
        }


    });


    var columnContainer = jQuery('.col-main');
    columnContainer.on('click', '#link_centralpay', function () {
        jQuery('#div_centralpay').slideDown("slow");
    });

    columnContainer.on("keyup", '#num', updateCardNumberIcon);
    columnContainer.on("keyup", '#month', function () {
        if (jQuery(this).val().length == 2) {
            jQuery("#year").focus();
        }
    });
    columnContainer.on("keyup", '#year', function () {
        if (jQuery(this).val().length == 2 && jQuery(this).val().indexOf('_') == -1) {
            jQuery("#cvv2").focus();
        }
    });

    jQuery('#cgv').on('click', function () {
        if (jQuery(this).prop('checked') == true) {
            champsForm = setInterval(function () {
                setMask();
            }, 1000);
        }
    });

    jQuery('#link_centralpay').on('click', function (e) {
        e.preventDefault();
        jQuery('#cpay-payment').stop().slideToggle();
        jQuery(this).stop().toggleClass('open');
    });

    jQuery('a[title]').qtip({position: {my: 'bottom center', at: 'top center'}});

    jQuery("#num").payment("formatCardNumber");
    jQuery("#month").inputmask('Regex', {regex: "^(0[1-9]|1[0-2])$"});
    jQuery("#year").inputmask("99");
    jQuery("#cvv2").payment("formatCardCVC");
    jQuery("#cvv3").payment("formatCardCVC");


    jQuery('body').on('focus', '#year,#month,#num,#cvv2', function () {
        jQuery('.validation-advice').remove();
    });


    jQuery('#name_centralpay').closest('form').data('centralpay', 'form');


    window.Centralpay ? Centralpay.card.setMerchantPublicKey(plublic_key) : alert('Error loading html form');


    jQuery('body').on('change', '#cardId', function () {

        if (jQuery(this).val() != '') {
            jQuery("#cvv3").focus();


        }

    })

    if (!onepage) {
        submit = true;
        jQuery('#payment-continue').on('click', function (event) {

            if (jQuery('#p_method_custompaymentmethod').is(':checked')) {
                if (jQuery('#cardId').length==0 || (jQuery('#cardId').length>0 && jQuery('#cardId').val() == '')) {
                   // alert('ok');
                    verifCentralpay = true;
                    jQuery('#name_centralpay').closest('form').data('centralpay', 'form');
                    event.preventDefault();
                    jQuery('#name_centralpay').closest('form').attr('action', new_url);
                    initForm(event);
                } else {
                    //alert('ko');
                    verifCentralpay = false;
                    jQuery('#name_centralpay').closest('form').removeData('centralpay');
                    initForm(event);
                    jQuery('#name_centralpay').closest('form').attr('action', new_url);
                    jQuery('#name_centralpay').closest('form').submit();
                }

                //  jQuery('#name_centralpay').closest('form').submit();


            } else {
                jQuery('#name_centralpay').closest('form').removeData('centralpay');

                jQuery('#name_centralpay').closest('form').attr('action', old_url);
                jQuery('#name_centralpay').closest('form').submit();
            }

        })


        if (jQuery('#review-order-form').length > 0 && methodPayment == 'custompaymentmethod') {
            jQuery('#review-order-form').attr('action', redirect_url);
            jQuery('#review-button').on('click', function (event) {
                event.preventDefault();
                //alert(redirect_url);
                document.location.href = redirect_url;

            })

        }


    } else {
        submit = false;
        jQuery('body').on('click', "input[id^='p_method']", function () {

            if (jQuery('#p_method_custompaymentmethod').is(':checked')) {

                jQuery('#checkout-step-payment .button').removeAttr('onclick');
                if (jQuery('#cardId').length==0 || (jQuery('#cardId').length>0 && jQuery('#cardId').val() == '')) {

                    jQuery('#name_centralpay').closest('form').data('centralpay', 'form');
                   // jQuery('#co-payment-form').data('centralpay', 'form');
                }
            } else {

                jQuery('#checkout-step-payment .button').attr('onclick', 'payment.save();');
            }


        });


        jQuery('body').on('click', '#checkout-step-payment .button', function () {


            if (jQuery('#cardId').length>0 &&  jQuery('#cardId').val() != '') {
                submit = true;
                verifCentralpay = false;
                jQuery('#num').removeClass('required-entry');
                jQuery('#year').removeClass('required-entry');
                jQuery('#month').removeClass('required-entry');
                jQuery('#cvv2').removeClass('required-entry');
                jQuery('#cvv3').addClass('required-entry');

                jQuery('#name_centralpay').closest('form').removeData('centralpay');
                initForm(event);
                var payment2 = new Payment('co-payment-form', savePayementUrl);
                payment2.save();


            } else {


                // jQuery('#num').addClass('required-entry');
                // jQuery('#year').addClass('required-entry');
                // jQuery('#month').addClass('required-entry');
                // jQuery('#cvv2').addClass('required-entry');
                jQuery('#num').removeClass('required-entry');
                jQuery('#year').removeClass('required-entry');
                jQuery('#month').removeClass('required-entry');
                jQuery('#cvv2').removeClass('required-entry');
                jQuery('#cvv3').removeClass('required-entry');
                verifCentralpay = true;
                submit = false;
                jQuery('#name_centralpay').closest('form').data('centralpay', 'form');
              //  jQuery('#co-payment-form').data('centralpay', 'form');
                initForm(event);
            }


        });

    }


});

